////////////////////////////////////////////////////////////////////////////////
// VBSAPI5 - Visual Basic interface to SAPI 5.0
// Created by Mike Reed - mikereed@unlimitedpotential.com
// Copyright 2000 - All Rights Reserved - Unlimited Potential, Inc.
////////////////////////////////////////////////////////////////////////////////
// In VB use the Project->References to add the DLL to the VB project.
// If you wish to speak the text aloud, pass an empty string for FileToSave
// If FileToSave includes data, then the speech will be written to the file specified
////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <sphelper.h>
#include <windows.h>
#include <ObjBase.h>
#include <sapi.h>


WCHAR						WideCharTextToSpeak[2048]; //Buffer to store wide version of text to speak
WCHAR						WideCharFileToSave[2048]; //Buffer to store wide version of filename
CComPtr<ISpStream>			cpWavStream;
CComPtr<ISpStreamFormat>    cpOldStream;
HRESULT			            hr = S_OK;

////////////////////////////////////////////////////////////////////////////////
void __stdcall Text2Wav(LPSTR TextToSpeak, LPSTR FileToSave)
////////////////////////////////////////////////////////////////////////////////
{
	int					TextToSpeakCount; //Number of charactors in converted wide TextToSpeak string
	int					FileToSaveCount; //Number of charactors in converted wide FileToSave string
	CSpStreamFormat		OriginalFmt; //Store original output stream format
	BOOL				FileNameExists;
	char				Filename[1024];
	int					P1;
	int					P2;
    char				eFmt[] = "SPSF_11kHz8BitMono";
    CSpStreamFormat		Fmt;
	
	//Convert any "\" in the filename to "\\"
	FileNameExists = FALSE;
	if (FileToSave != 0)
	{
		FileNameExists = TRUE;
		P1 = 0;
		P2 = 0;
		for (P1 = 0; FileToSave[P1] != 0; P1++)
		{
			Filename[P2] = FileToSave[P1];
			P2++;
			Filename[P2] = 0;
			if (FileToSave[P1] == '\\')
			{
				Filename[P2] = '\\';
				P2++;
				Filename[P2] = 0;
			}
		}
	}
	
	//Convert VB String (sequence of multibyte characters) to 
	//Wide charactor string (sequence of wide characters).
	TextToSpeakCount = mbstowcs(WideCharTextToSpeak, TextToSpeak, 1024);
	if (FileNameExists)
	{
		FileToSaveCount = mbstowcs(WideCharFileToSave, Filename, 1024);
	}

	//Init COM
	if (SUCCEEDED(::CoInitialize(NULL)))
	{
		ISpVoice * pVoice; //Define pointer to ISpVoice - The heart of SAPI
		if (SUCCEEDED(::CoCreateInstance(CLSID_SpVoice, NULL, CLSCTX_ALL, IID_ISpVoice, (void **)&pVoice)))
		{
			//Now we can call any of the ISpVoice based functions.

			if (FileNameExists)
			{
				hr = pVoice->GetOutputStream( &cpOldStream );
				if (hr == S_OK)
				{
					hr = OriginalFmt.AssignFormat(cpOldStream);
				}
				else
				{
					hr = E_FAIL;
				}
				// User SAPI helper function in sphelper.h to create a wav file
				if (SUCCEEDED(hr))
				{
//					pVoice->GetFormat(
//	                Fmt.AssignFormat(eFmt); //Set Format
//					hr = SPBindToFile( WideCharFileToSave, SPFM_CREATE_ALWAYS, &cpWavStream, SPDFID_WaveFormatEx, OriginalFmt.WaveFormatExPtr() ); 
					
//					OriginalFmt.WaveFormatExPtr(FormatTag) = 1;
//					(*(OriginalFmt.WaveFormatExPtr())).nChannels = 1;
//					(*(OriginalFmt.WaveFormatExPtr())).nSamplesPerSec = 11025;
//					(*(OriginalFmt.WaveFormatExPtr())).nAvgBytesPerSec = 11025;
//					(*(OriginalFmt.WaveFormatExPtr())).nBlockAlign = 1;
//					(*(OriginalFmt.WaveFormatExPtr())).wBitsPerSample = 8;
//					(*(OriginalFmt.WaveFormatExPtr())).cbSize = 0;
					//Binds the audio stream to the specified file. 
					hr = SPBindToFile( WideCharFileToSave, SPFM_CREATE_ALWAYS, &cpWavStream, &OriginalFmt.FormatId(), OriginalFmt.WaveFormatExPtr() ); 
				}
				if( SUCCEEDED( hr ) )
				{
					// Set the voice's output to the wav file instead of the speakers
					hr = pVoice->SetOutput(cpWavStream, TRUE);
				}
			}			
			
			
			pVoice->Speak(WideCharTextToSpeak, 0, NULL); //Speak the passed string

			
			if (FileNameExists)
			{
				pVoice->WaitUntilDone( INFINITE );
				cpWavStream.Release();
				
				// Reset output
				pVoice->SetOutput( cpOldStream, FALSE );
			}			
			
			pVoice->Release(); //Release ISpVoice
			pVoice = NULL; //Clear the pointer
		}
		::CoUninitialize(); //Release COM
	}
}

